## openzwave 1.5+ds

=== Makefile ===
#
# Makefile for OpenzWave Mac OS X applications
# Greg Satz

# GNU make only

# requires libudev-dev

.SUFFIXES:	.d .cpp .o .a
.PHONY:	default clean install


top_srcdir := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
top_builddir ?= $(CURDIR)
export top_builddir
PREFIX ?= /usr/local
export PREFIX

all: 
	CPPFLAGS=$(CPPFLAGS) $(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) 
	CPPFLAGS=$(CPPFLAGS) $(MAKE) -C $(top_srcdir)/cpp/examples/MinOZW/ -$(MAKEFLAGS) 

install:
	$(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) $(MAKECMDGOALS)
	$(MAKE) -C $(top_srcdir)/cpp/examples/MinOZW/ -$(MAKEFLAGS) $(MAKECMDGOALS)

clean:
	$(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) $(MAKECMDGOALS)
	$(MAKE) -C $(top_srcdir)/cpp/examples/MinOZW/ -$(MAKEFLAGS) $(MAKECMDGOALS)

cpp/src/vers.cpp:
	CPPFLAGS=$(CPPFLAGS) $(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) cpp/src/vers.cpp

check: xmltest

include $(top_srcdir)/cpp/build/support.mk

ifeq ($(XMLLINT),)
xmltest:	$(XMLLINT)
	$(error xmllint command not found.)
else
xmltest:	$(XMLLINT)
	@$(XMLLINT) --noout --schema $(top_srcdir)/config/device_classes.xsd $(top_srcdir)/config/device_classes.xml
	@$(XMLLINT) --noout --schema $(top_srcdir)/config/options.xsd $(top_srcdir)/config/options.xml
	@$(XMLLINT) --noout --schema $(top_srcdir)/config/manufacturer_specific.xsd $(top_srcdir)/config/manufacturer_specific.xml
	@$(XMLLINT) --noout --schema $(top_srcdir)/config/device_configuration.xsd $(top_srcdir)/config/*/*.xml
endif


dist-update:
	@echo "Updating List of Distribition Files"
	@$(GIT) ls-files > .distfiles
	@$(top_srcdir)/makedist

DIST_FORMATS ?= gzip

include $(top_srcdir)/distfiles.mk
include $(top_srcdir)/dist.mk

=== cpp/build/Makefile ===
#
# Makefile for OpenZWave Linux build
# Greg Satz

# GNU make only

# Linux requires libudev-dev
# FreeBSD requires port misc/e2fsprogs-libuuid



#these variables can be modified by the user if needed


# what flags we will use for compiling in debug mode
DEBUG_CFLAGS    := -Wall -Wno-unknown-pragmas -Wno-inline -Wno-format -Werror -Wno-error=sequence-point -Wno-sequence-point -ggdb -DDEBUG -fPIC  -DSYSCONFDIR="\"$(PREFIX)/etc/openzwave/\""
# what flags we will use for compiling in release mode
RELEASE_CFLAGS  := -Wall -Wno-unknown-pragmas -Werror -Wno-format -Wno-error=sequence-point -Wno-sequence-point -O3 -DNDEBUG -fPIC  -DSYSCONFDIR="\"$(PREFIX)/etc/openzwave/\""
#what flags we will use for linking in debug mode
DEBUG_LDFLAGS	:= -g

top_srcdir := $(abspath $(dir $(lastword $(MAKEFILE_LIST)))../../)

include $(top_srcdir)/cpp/build/support.mk

#Mac prefers a dylib, not a so
ifeq ($(UNAME),Darwin)
SHARED_LIB_NAME=libopenzwave-$(VERSION).dylib
SHARED_LIB_UNVERSIONED=libopenzwave.dylib
else
SHARED_LIB_NAME=libopenzwave.so.$(VERSION)
SHARED_LIB_UNVERSIONED=libopenzwave.so
endif

#if we are on a Mac, add these flags and libs to the compile and link phases 
ifeq ($(UNAME),Darwin)
CFLAGS	+= -c -DDARWIN
TARCH	+= -arch i386 -arch x86_64
LDFLAGS += -dynamiclib
LIBS	+= -framework IOKit -framework CoreFoundation -arch i386 -arch x86_64
else ifeq ($(UNAME),FreeBSD)

# FreeBSD 10 has native iconv.h; for older, we look in /usr/local, and libiconv must be installed from ports.
ifeq (,$(wildcard /usr/include/iconv.h))
CFLAGS += -I/usr/local/include
endif
LDFLAGS+= -shared -lusb

else
LDFLAGS += -shared -Wl,-soname,libopenzwave.so.$(VERSION)
LIBS 	+= -ludev
endif
CFLAGS  += $(CPPFLAGS)

#where to put the temporary library
LIBDIR	?= $(top_builddir)

INCLUDES	:= -I $(top_srcdir)/cpp/src -I $(top_srcdir)/cpp/tinyxml/ -I $(top_srcdir)/cpp/hidapi/hidapi/

ifeq ($(UNAME),Darwin)
SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/mac
else ifeq ($(UNAME),FreeBSD)
SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/libusb
else
SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/linux
endif


SOURCES		:= $(top_srcdir)/cpp/src $(top_srcdir)/cpp/src/command_classes $(top_srcdir)/cpp/tinyxml \
	$(top_srcdir)/cpp/src/value_classes $(top_srcdir)/cpp/src/platform $(top_srcdir)/cpp/src/platform/unix $(SOURCES_HIDAPI) $(top_srcdir)/cpp/src/aes/
VPATH = $(top_srcdir)/cpp/src:$(top_srcdir)/cpp/src/command_classes:$(top_srcdir)/cpp/tinyxml:\
	$(top_srcdir)/cpp/src/value_classes:$(top_srcdir)/cpp/src/platform:$(top_srcdir)/cpp/src/platform/unix:$(SOURCES_HIDAPI):$(top_srcdir)/cpp/src/aes/
	

tinyxml := $(notdir $(wildcard $(top_srcdir)/cpp/tinyxml/*.cpp))

ifeq ($(UNAME),Darwin)
hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/mac/*.c))
else ifeq ($(UNAME),FreeBSD)
hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/libusb/*.c))
else
hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/linux/*.c)) # we do not want the libusb version
endif

cclasses := $(notdir $(wildcard $(top_srcdir)/cpp/src/command_classes/*.cpp))
vclasses := $(notdir $(wildcard $(top_srcdir)/cpp/src/value_classes/*.cpp))
pform := $(notdir $(wildcard $(top_srcdir)/cpp/src/platform/*.cpp)) \
	$(notdir $(wildcard $(top_srcdir)/cpp/src/platform/unix/*.cpp))
indep := $(notdir $(filter-out $(top_srcdir)/cpp/src/vers.cpp, $(wildcard $(top_srcdir)/cpp/src/*.cpp)))
aes := $(notdir $(wildcard $(top_srcdir)/cpp/src/aes/*.c))


default: printversion $(LIBDIR)/libopenzwave.a $(LIBDIR)/$(SHARED_LIB_NAME) $(top_builddir)/ozw_config

clean:
	@rm -rf $(DEPDIR) $(OBJDIR) $(LIBDIR)/libopenzwave.so* $(LIBDIR)/libopenzwave*.dylib $(LIBDIR)/libopenzwave.a $(top_builddir)/libopenzwave.pc $(top_builddir)/docs/api $(top_builddir)/Doxyfile $(top_srcdir)/cpp/src/vers.cpp

printversion:
	@echo "Building OpenZWave Version $(GITVERSION)"	


-include $(patsubst %.cpp,$(DEPDIR)/%.d,$(tinyxml))
-include $(patsubst %.c,$(DEPDIR)/%.d,$(hidapi))
-include $(patsubst %.cpp,$(DEPDIR)/%.d,$(cclasses))
-include $(patsubst %.cpp,$(DEPDIR)/%.d,$(vclasses))
-include $(patsubst %.cpp,$(DEPDIR)/%.d,$(pform))
-include $(patsubst %.cpp,$(DEPDIR)/%.d,$(indep))
-include $(patsubst %.c,$(DEPDIR)/%.d,$(aes))

#create a vers.cpp file that contains our version and subversion revisions
$(top_srcdir)/cpp/src/vers.cpp:
	@echo "Creating vers.cpp"
	@echo '#include "Defs.h"' > $(top_srcdir)/cpp/src/vers.cpp
	@echo 'uint16_t ozw_vers_major = $(VERSION_MAJ);' >> $(top_srcdir)/cpp/src/vers.cpp
	@echo 'uint16_t ozw_vers_minor = $(VERSION_MIN);' >> $(top_srcdir)/cpp/src/vers.cpp
	@echo 'uint16_t ozw_vers_revision = $(VERSION_REV);' >> $(top_srcdir)/cpp/src/vers.cpp
	@echo 'char ozw_version_string[] = "$(GITVERSION)";' >> $(top_srcdir)/cpp/src/vers.cpp
	

#$(OBJDIR)/vers.o:	$(top_builddir)/vers.cpp

$(LIBDIR)/libopenzwave.a:	$(patsubst %.cpp,$(OBJDIR)/%.o,$(tinyxml)) \
			$(patsubst %.c,$(OBJDIR)/%.o,$(hidapi)) \
			$(patsubst %.c,$(OBJDIR)/%.o,$(aes)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(cclasses)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(vclasses)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(pform)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(indep)) \
			$(OBJDIR)/vers.o
	@echo "Linking Static Library"
	@$(AR) $@ $+
	@$(RANLIB) $@

$(LIBDIR)/$(SHARED_LIB_NAME):	$(patsubst %.cpp,$(OBJDIR)/%.o,$(tinyxml)) \
			$(patsubst %.c,$(OBJDIR)/%.o,$(hidapi)) \
			$(patsubst %.c,$(OBJDIR)/%.o,$(aes)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(cclasses)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(vclasses)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(pform)) \
			$(patsubst %.cpp,$(OBJDIR)/%.o,$(indep)) \
			$(OBJDIR)/vers.o
	@echo "Linking Shared Library"
	@$(LD) $(LDFLAGS) $(TARCH) -o $@ $+ $(LIBS)
	@ln -sf $(SHARED_LIB_NAME) $(LIBDIR)/$(SHARED_LIB_UNVERSIONED)

$(top_builddir)/libopenzwave.pc: $(top_srcdir)/cpp/build/libopenzwave.pc.in $(PKGCONFIG)
	@echo "Making libopenzwave pkg-config file"
	@$(SED) \
		-e 's|[@]prefix@|$(PREFIX)|g' \
		-e 's|[@]exec_prefix@|$(PREFIX)/bin|g' \
		-e 's|[@]libdir@|$(instlibdir)|g' \
		-e 's|[@]includedir@|$(PREFIX)/include/openzwave/|g' \
                -e 's|[@]sysconfdir@|$(PREFIX)/etc/openzwave/|g' \
                -e 's|[@]gitversion@|$(GITVERSION)|g' \
                -e 's|[@]docdir@|$(docdir)/|g' \
		-e 's|[@]VERSION@|$(VERSION)|g' \
		< "$<" > "$@"
$(top_builddir)/ozw_config: $(top_srcdir)/cpp/build/ozw_config.in
	@echo "Making ozw_config file"
	@$(SED) \
		-e 's|[@]pkgconfigfile@|$(pkgconfigdir)/libopenzwave.pc|g' \
		< "$<" > "$@"
	@chmod +x $(top_builddir)/ozw_config
	
ifeq ($(DOT),)
HAVE_DOT = -e 's|[@]HAVE_DOT@|NO|g' 
else
HAVE_DOT = -e 's|[@]HAVE_DOT@|YES|g' 
endif

$(top_builddir)/Doxyfile: $(top_srcdir)/docs/Doxyfile.in $(top_srcdir)/cpp/src/vers.cpp
	@mkdir -p $(top_builddir)/docs/api/
	@$(SED) \
		-e 's|[@]OUTPUT_DIR@|$(top_builddir)/docs/api/|g' \
		-e 's|[@]TOPSRC_DIR@|$(top_srcdir)|g' \
		$(HAVE_DOT) \
		-e 's|[@]VERSION@|$(VERSION).$(VERSION_REV)|g' \
		< "$<" > "$@"

ifeq ($(DOXYGEN),)
doc:
		$(warning Documentation not being built)
else
doc: $(top_builddir)/Doxyfile
	@echo "Creating Documentation at $(top_builddir)/docs/api/"
	@mkdir -p $(top_builddir)/docs/api/
	@cd $(top_builddir); $(DOXYGEN)
endif

install: $(LIBDIR)/$(SHARED_LIB_NAME) doc $(top_builddir)/libopenzwave.pc $(top_builddir)/ozw_config
	@echo "Installing Shared Library"
	@install -d $(DESTDIR)/$(instlibdir)/
	@cp  $(LIBDIR)/$(SHARED_LIB_NAME) $(DESTDIR)/$(instlibdir)/$(SHARED_LIB_NAME)
	@ln -sf $(SHARED_LIB_NAME) $(DESTDIR)/$(instlibdir)/$(SHARED_LIB_UNVERSIONED)
	@echo "Installing Headers"
	@install -d $(DESTDIR)/$(includedir)
	@install -m 0644 $(top_srcdir)/cpp/src/*.h $(DESTDIR)/$(includedir)
	@install -d $(DESTDIR)/$(includedir)/command_classes/
	@install -m 0644 $(top_srcdir)/cpp/src/command_classes/*.h $(DESTDIR)/$(includedir)/command_classes/
	@install -d $(DESTDIR)/$(includedir)/value_classes/
	@install -m 0644 $(top_srcdir)/cpp/src/value_classes/*.h $(DESTDIR)/$(includedir)/value_classes/
	@install -d $(DESTDIR)/$(includedir)/platform/
	@install -m 0644 $(top_srcdir)/cpp/src/platform/*.h $(DESTDIR)/$(includedir)/platform/	
	@install -d $(DESTDIR)/$(includedir)/platform/unix/
	@install -m 0644 $(top_srcdir)/cpp/src/platform/unix/*.h $(DESTDIR)/$(includedir)/platform/unix/
	@install -d $(DESTDIR)/$(includedir)/aes/
	@install -m 0644 $(top_srcdir)/cpp/src/aes/*.h $(DESTDIR)/$(includedir)/aes/
	@install -d $(DESTDIR)/$(sysconfdir)/
	@echo "Installing Config Database"
	@cp -r $(top_srcdir)/config/* $(DESTDIR)/$(sysconfdir)
	@echo "Installing Documentation"
	@install -d $(DESTDIR)/$(docdir)/
	@cp -r $(top_srcdir)/docs/* $(DESTDIR)/$(docdir)
	@if [ -d "$(top_builddir)/docs/html/" ]; then cp -r $(top_builddir)/docs/html/* $(DESTDIR)/$(docdir); fi
	@echo "Installing Pkg-config Files"
	@install -d $(DESTDIR)/$(pkgconfigdir) 
	@cp $(top_builddir)/libopenzwave.pc $(DESTDIR)/$(pkgconfigdir)
	@install -d $(DESTDIR)/$(PREFIX)/bin/
	@cp $(top_builddir)/ozw_config $(DESTDIR)/$(PREFIX)/bin/ozw_config
	@chmod 755 $(DESTDIR)/$(PREFIX)/bin/ozw_config

	

.SUFFIXES:	.d .cpp .o .a
.PHONY:	default clean install doc

=== cpp/tinyxml/Makefile ===
#****************************************************************************
#
# Makefile for TinyXml test.
# Lee Thomason
# www.grinninglizard.com
#
# This is a GNU make (gmake) makefile
#****************************************************************************

# DEBUG can be set to YES to include debugging info, or NO otherwise
DEBUG          := YES

# PROFILE can be set to YES to include profiling info, or NO otherwise
PROFILE        := NO

# TINYXML_USE_STL can be used to turn on STL support. NO, then STL
# will not be used. YES will include the STL files.
TINYXML_USE_STL := YES

#****************************************************************************

CC     := gcc
CXX    := g++
LD     := g++
AR     := ar rc
RANLIB := ranlib

DEBUG_CFLAGS     := -Wall -Wno-format -g -DDEBUG $(CPPFLAGS)
RELEASE_CFLAGS   := -Wall -Wno-unknown-pragmas -Wno-format -O3 $(CPPFLAGS)

LIBS		 :=

DEBUG_CXXFLAGS   := ${DEBUG_CFLAGS} 
RELEASE_CXXFLAGS := ${RELEASE_CFLAGS}

DEBUG_LDFLAGS    := -g
RELEASE_LDFLAGS  :=

ifeq (YES, ${DEBUG})
   CFLAGS       := ${DEBUG_CFLAGS}
   CXXFLAGS     := ${DEBUG_CXXFLAGS}
   LDFLAGS      := ${DEBUG_LDFLAGS}
else
   CFLAGS       := ${RELEASE_CFLAGS}
   CXXFLAGS     := ${RELEASE_CXXFLAGS}
   LDFLAGS      := ${RELEASE_LDFLAGS}
endif

ifeq (YES, ${PROFILE})
   CFLAGS   := ${CFLAGS} -pg -O3
   CXXFLAGS := ${CXXFLAGS} -pg -O3
   LDFLAGS  := ${LDFLAGS} -pg
endif

#****************************************************************************
# Preprocessor directives
#****************************************************************************

ifeq (YES, ${TINYXML_USE_STL})
  DEFS := -DTIXML_USE_STL
else
  DEFS :=
endif

#****************************************************************************
# Include paths
#****************************************************************************

#INCS := -I/usr/include/g++-2 -I/usr/local/include
INCS :=


#****************************************************************************
# Makefile code common to all platforms
#****************************************************************************

CFLAGS   := ${CFLAGS}   ${DEFS}
CXXFLAGS := ${CXXFLAGS} ${DEFS}

#****************************************************************************
# Targets of the build
#****************************************************************************

OUTPUT := xmltest

all: ${OUTPUT}


#****************************************************************************
# Source files
#****************************************************************************

SRCS := tinyxml.cpp tinyxmlparser.cpp xmltest.cpp tinyxmlerror.cpp tinystr.cpp

# Add on the sources for libraries
SRCS := ${SRCS}

OBJS := $(addsuffix .o,$(basename ${SRCS}))

#****************************************************************************
# Output
#****************************************************************************

${OUTPUT}: ${OBJS}
	${LD} -o $@ ${LDFLAGS} ${OBJS} ${LIBS} ${EXTRA_LIBS}

#****************************************************************************
# common rules
#****************************************************************************

# Rules for compiling source files to object files
%.o : %.cpp
	${CXX} -c ${CXXFLAGS} ${INCS} $< -o $@

%.o : %.c
	${CC} -c ${CFLAGS} ${INCS} $< -o $@

dist:
	bash makedistlinux

clean:
	-rm -f core ${OBJS} ${OUTPUT}

depend:
	#makedepend ${INCS} ${SRCS}

tinyxml.o: tinyxml.h tinystr.h
tinyxmlparser.o: tinyxml.h tinystr.h
xmltest.o: tinyxml.h tinystr.h
tinyxmlerror.o: tinyxml.h tinystr.h

=== cpp/examples/MinOZW/Makefile ===
#
# Makefile for OpenzWave Mac OS X applications
# Greg Satz

# GNU make only

# requires libudev-dev

.SUFFIXES:	.d .cpp .o .a
.PHONY:	default clean


DEBUG_CFLAGS    := -Wall -Wno-format -ggdb -DDEBUG $(CPPFLAGS)
RELEASE_CFLAGS  := -Wall -Wno-unknown-pragmas -Wno-format -O3 $(CPPFLAGS)

DEBUG_LDFLAGS	:= -g

top_srcdir := $(abspath $(dir $(lastword $(MAKEFILE_LIST)))../../../)


INCLUDES	:= -I $(top_srcdir)/cpp/src -I $(top_srcdir)/cpp/tinyxml/ -I $(top_srcdir)/cpp/hidapi/hidapi/
LIBS =  $(wildcard $(LIBDIR)/*.so $(LIBDIR)/*.dylib $(top_builddir)/*.so $(top_builddir)/*.dylib $(top_builddir)/cpp/build/*.so $(top_builddir)/cpp/build/*.dylib )
LIBSDIR = $(abspath $(dir $(firstword $(LIBS))))
minozwsrc := $(notdir $(wildcard $(top_srcdir)/cpp/examples/MinOZW/*.cpp))
VPATH := $(top_srcdir)/cpp/examples/MinOZW

top_builddir ?= $(CURDIR)

default: $(top_builddir)/MinOZW

include $(top_srcdir)/cpp/build/support.mk

-include $(patsubst %.cpp,$(DEPDIR)/%.d,$(minozwsrc))

#if we are on a Mac, add these flags and libs to the compile and link phases 
ifeq ($(UNAME),Darwin)
CFLAGS += -DDARWIN
TARCH += -arch i386 -arch x86_64
endif

# Dup from main makefile, but that is not included when building here..
ifeq ($(UNAME),FreeBSD)
ifeq (,$(wildcard /usr/include/iconv.h))
CFLAGS += -I/usr/local/include
LDFLAGS+= -L/usr/local/lib -liconv
endif
LDFLAGS+= -lusb
endif

$(OBJDIR)/MinOZW:	$(patsubst %.cpp,$(OBJDIR)/%.o,$(minozwsrc))
	@echo "Linking $(OBJDIR)/MinOZW"
	$(LD) $(LDFLAGS) $(TARCH) -o $@ $< $(LIBS) -pthread

$(top_builddir)/MinOZW: $(top_srcdir)/cpp/examples/MinOZW/MinOZW.in $(OBJDIR)/MinOZW
	@echo "Creating Temporary Shell Launch Script"
	@$(SED) \
		-e 's|[@]LDPATH@|$(LIBSDIR)|g' \
		< "$<" > "$@"
	@chmod +x $(top_builddir)/MinOZW

clean:
	@rm -rf $(DEPDIR) $(OBJDIR) $(top_builddir)/MinOZW

ifeq ($(XMLLINT),)
xmltest:	$(XMLLINT)
	$(error xmllint command not found.)
else
xmltest:	$(XMLLINT)
	@$(XMLLINT) --noout --schema ../../../config/zwcfg.xsd zwcfg_*.xml
	@$(XMLLINT) --noout --schema ../../../config/zwscene.xsd zwscene.xml
endif

install: $(OBJDIR)/MinOZW
	@echo "Installing into Prefix: $(PREFIX)"
	@install -d $(DESTDIR)/$(PREFIX)/bin/
	@cp $(OBJDIR)/MinOZW $(DESTDIR)/$(PREFIX)/bin/MinOZW
	@chmod 755 $(DESTDIR)/$(PREFIX)/bin/MinOZW

=== cpp/build/windows/mingw32/Makefile ===
#
# Makefile for OpenZWave MingW32 build
# Maarten Damen

.SUFFIXES:	.d .cpp .o .a
.PHONY:	default clean

CC     := $(CROSS_COMPILE)gcc
CXX    := $(CROSS_COMPILE)g++
LD     := $(CROSS_COMPILE)g++
AR     := $(CROSS_COMPILE)ar rc
RANLIB := $(CROSS_COMPILE)ranlib

DEBUG_CFLAGS    := -Wall -Wno-format -g -DDEBUG -DLOG_STDERR -DMINGW
RELEASE_CFLAGS  := -Wall -Wno-unknown-pragmas -Wno-format -O3 -DMINGW

DEBUG_LDFLAGS	:= -g

# Change for DEBUG or RELEASE
CFLAGS	:= -c $(DEBUG_CFLAGS)
LDFLAGS	:= $(DEBUG_LDFLAGS)

LIBDIR	:= ../../../lib/windows-mingw32

INCLUDES	:= -I ../../../src -I ../../../src/command_classes/ -I ../../../src/value_classes/ \
	-I ../../../src/platform/ -I ../../../src/platform/windows -I ../../../tinyxml/ -I ../../../hidapi/hidapi/
SOURCES		:= ../../../src ../../../src/command_classes ../../../tinyxml ../../../hidapi/windows \
	../../../src/value_classes ../../../src/platform ../../../src/platform/windows

VPATH = ../../../src:../../../src/command_classes:../../../tinyxml:../../../hidapi/windows:\
	../../../src/value_classes:../../../src/platform:../../../src/platform/windows

%.d : %.cpp
	@set -e; rm -f $@; \
	$(CXX) -MM $(INCLUDES) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
	rm -f $@.$$$$

tinyxml := $(notdir $(wildcard ../../../tinyxml/*.cpp))
hidapi := $(notdir $(wildcard ../../../hidapi/linux/hid.c)) # we do not want the libusb version
cclasses := $(notdir $(wildcard ../../../src/command_classes/*.cpp))
vclasses := $(notdir $(wildcard ../../../src/value_classes/*.cpp))
pform := $(notdir $(wildcard ../../../src/platform/*.cpp)) \
	$(notdir $(wildcard ../../../src/platform/windows/*.cpp))
indep := $(notdir $(wildcard ../../../src/*.cpp))

%.o : %.cpp
	$(CXX) $(CFLAGS) $(INCLUDES) -o $@ $<

%.o : %.c
	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $<

default:	$(LIBDIR)/openzwave.a

clean:
	rm -f *.d *.o

-include $(tinyxml:.cpp=.d)
-include $(hidapi:.c=.d)
-include $(cclasses:.cpp=.d)
-include $(vclasses:.cpp=.d)
-include $(pform:.cpp=.d)
-include $(indep:.cpp=.d)

vers.c:
	echo 'char ozw_vers[] = "OpenZWave version 1.0.'`svnversion ../..`'";' > vers.c

vers.o:	vers.c

$(LIBDIR)/openzwave.a:	$(patsubst %.cpp,%.o,$(tinyxml)) \
			$(patsubst %.c,%.o,$(hidapi)) \
			$(patsubst %.cpp,%.o,$(cclasses)) \
			$(patsubst %.cpp,%.o,$(vclasses)) \
			$(patsubst %.cpp,%.o,$(pform)) \
			$(patsubst %.cpp,%.o,$(indep)) vers.o
	$(AR) $@ $?

## openzwave 1.5%2Bds

=== debian/changelog ===
openzwave (1.5+ds-6) unstable; urgency=medium

  * debian/control: use dh11
  * debian/control: bump to version 4.1.5 (no changes)
  * debian/control: usa salsa VCS URLs
  * debian/control: add 'Suggests: libopenzwave-doc' to dev package
                    (Closes: #849606)
  * add gcc8.patch to avoid FTBFS (Closes: #897828)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 10 Jul 2018 19:20:00 +0200

openzwave (1.5+ds-5) unstable; urgency=medium

  * debian/control: bump to version 4.0.1 (no changes)
  * debian/control: use dh 10 now
  * debian/rules: more compiler options to make gcc7 happy (Closes: #871088)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 21 Aug 2017 19:20:00 +0200

openzwave (1.5+ds-4) unstable; urgency=medium

  * move maintenance to debian-iot

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 23 Dec 2016 19:10:00 +0100

openzwave (1.5+ds-3) unstable; urgency=medium

  * debian/control: add VCS URLs
  * install modified tinyxml headers (Closes: #839281)
    thanks to Dara Adib for the suggestion and the patch

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 12 Dec 2016 21:10:00 +0100

openzwave (1.5+ds-2) unstable; urgency=medium

  * move from non-free to main
    (comment in debian/copyright for AESBSD)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 29 Nov 2016 21:10:00 +0100

openzwave (1.5+ds-1) unstable; urgency=medium

  * Initial release (Closes: #791965)
    (cannot be in main due to cpp/src/aes/*)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 13 Sep 2016 18:10:00 +0200

=== debian/control ===
Source: openzwave
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Section: devel
Priority: optional
Build-Depends: debhelper (>=11)
	, dh-exec (>=0.2)
	, g++ (>= 4.4)
	, quilt
	, libudev-dev
	, libxml2-utils
	, gcc-8, g++-8
Standards-Version: 4.1.5
Homepage: http://www.openzwave.com/
Vcs-Browser: https://salsa.debian.org/debian-iot-team/openzwave
Vcs-Git: https://salsa.debian.org/debian-iot-team/openzwave.git

Package: libopenzwave1.5
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: API to use a Z-Wave controller
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.
 .
 This package contains the library.

Package: libopenzwave1.5-dev
Section: libdevel
Depends: ${misc:Depends}, libopenzwave1.5 (= ${binary:Version})
Suggests: libopenzwave-doc
Architecture: any
Description: header files for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.
 .
 This package contains files for developing.

Package: libopenzwave-doc
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Architecture: all
Description: documentation for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.
 .
 This package contains documentation.

Package: openzwave
Section: misc
Architecture: any
Depends: libopenzwave1.5 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Sample Program for libopenzwave
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.

## openzwave 1.5+ds

=== debian/control ===
Source: openzwave
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Section: devel
Priority: optional
Build-Depends: debhelper (>=10), dh-exec (>=0.2), g++ (>= 4.4), quilt, libudev-dev, libxml2-utils
Standards-Version: 4.0.1
Homepage: http://www.openzwave.com/
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/openzwave.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/openzwave.git

Package: libopenzwave1.5
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: API to use a Z-Wave controller
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.
 .
 This package contains the library.

Package: libopenzwave1.5-dev
Section: libdevel
Depends: ${misc:Depends}, libopenzwave1.5 (= ${binary:Version})
Architecture: any
Description: header files for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.
 .
 This package contains files for developing.

Package: libopenzwave-doc
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Architecture: all
Description: documentation for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.
 .
 This package contains documentation.

Package: openzwave
Section: misc
Architecture: any
Depends: libopenzwave1.5 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends} 
Description: Sample Program for libopenzwave 
 OpenZWave is an open-source, cross-platform library designed to enable 
 anyone to add support for Z-Wave home-automation devices to their 
 applications, without requiring any in depth knowledge of the Z-Wave 
 protocol.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
#XXX: MORECPPFLAGS=-fPIE -pie
# add CFLAGS here as upstream make does not care about them and we need -Wformat
MORECPPFLAGS=$(CFLAGS)
MORELDFLAGS:=-Wl,-z,now

ifndef DESTDIR
DESTDIR=$(CURDIR)/debian/tmp/
endif

DEBVERS := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
VERSION := $(shell echo '$(DEBVERS)' | sed -e 's/^[\[:digit:]]*://' -e 's/[-].*//')
MAJOR := $(shell echo '$(VERSION)' | awk -F . {'print $$1'})
MINOR := $(shell echo '$(VERSION)' | awk -F . {'print $$2'} | awk -F '+' {'print $$1'})
REV := $(shell echo '$(VERSION)' | awk -F . {'print $$3'})
ifeq ($(strip $(REV)),)
  REV:=0
endif
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR := /usr/lib/$(DEB_HOST_MULTIARCH)/

%:
	dh $@

override_dh_clean:
	rm -f ozw_config doxygen.log
	dh_clean

override_dh_auto_build:
	echo "Build version: >$(MAJOR).$(MINOR).$(REV)<"
	LDFLAGS="$(LDFLAGS) $(MORELDFLAGS)" CPPFLAGS="$(CPPFLAGS) $(MORECPPFLAGS)" VERSION_MAJ=$(MAJOR) VERSION_MIN=$(MINOR) VERSION_REV=$(REV) PREFIX=/usr SYSCONFDIR=/etc/openzwave instlibdir=$(LIBDIR) make

override_dh_auto_install:
	VERSION_MAJ=$(MAJOR) VERSION_MIN=$(MINOR) VERSION_REV=$(REV) DESTDIR=$(DESTDIR) PREFIX=/usr SYSCONFDIR=/etc/openzwave instlibdir=$(LIBDIR) make install
	# install docs in /usr/share/doc/openzwave/, not openzwave-VERSION
	install -d debian/libopenzwave-doc/usr/share/doc
	###mv debian/tmp/usr/share/doc/openzwave-1* debian/libopenzwave-doc/usr/share/doc/openzwave
	# install config files in /etc/
	install -d debian/libopenzwave1.5/etc
	mv debian/tmp/usr/etc/openzwave debian/libopenzwave1.5/etc/

update_debian_version:
	sed -i '1 s/(.*)/($(shell git describe --long --tags --dirty | sed s/-/./g | sed s/^v// ))/' debian/changelog

get-orig-source:
	uscan --force-download --debug --repack

## openzwave 1.6+ds

=== Makefile ===
--- 
+++ 
@@ -16,9 +16,12 @@
 PREFIX ?= /usr/local
 export PREFIX
 
+UNAME := $(shell uname)
+export UNAME
+
 all: 
-	CPPFLAGS=$(CPPFLAGS) $(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) 
-	CPPFLAGS=$(CPPFLAGS) $(MAKE) -C $(top_srcdir)/cpp/examples/MinOZW/ -$(MAKEFLAGS) 
+	LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" $(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS)
+	LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" $(MAKE) -C $(top_srcdir)/cpp/examples/MinOZW/ -$(MAKEFLAGS)
 
 install:
 	$(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) $(MAKECMDGOALS)
@@ -27,9 +30,13 @@
 clean:
 	$(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) $(MAKECMDGOALS)
 	$(MAKE) -C $(top_srcdir)/cpp/examples/MinOZW/ -$(MAKEFLAGS) $(MAKECMDGOALS)
+	$(MAKE) -C $(top_srcdir)/cpp/test/ -$(MAKEFLAGS) $(MAKECMDGOALS)
+
+test:
+	$(MAKE) -C $(top_srcdir)/cpp/test/ -$(MAKEFLAGS) $(MAKECMDGOALS)
 
 cpp/src/vers.cpp:
-	CPPFLAGS=$(CPPFLAGS) $(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) cpp/src/vers.cpp
+	LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" $(MAKE) -C $(top_srcdir)/cpp/build/ -$(MAKEFLAGS) $(top_srcdir)/cpp/src/vers.cpp
 
 check: xmltest
 
@@ -43,8 +50,14 @@
 	@$(XMLLINT) --noout --schema $(top_srcdir)/config/device_classes.xsd $(top_srcdir)/config/device_classes.xml
 	@$(XMLLINT) --noout --schema $(top_srcdir)/config/options.xsd $(top_srcdir)/config/options.xml
 	@$(XMLLINT) --noout --schema $(top_srcdir)/config/manufacturer_specific.xsd $(top_srcdir)/config/manufacturer_specific.xml
+	@$(XMLLINT) --noout --schema $(top_srcdir)/config/Localization.xsd $(top_srcdir)/config/Localization.xml
+	@$(XMLLINT) --noout --schema $(top_srcdir)/config/NotificationCCTypes.xsd $(top_srcdir)/config/NotificationCCTypes.xml
 	@$(XMLLINT) --noout --schema $(top_srcdir)/config/device_configuration.xsd $(top_srcdir)/config/*/*.xml
+	-@cpp/build/testconfig.pl
 endif
+fulltest:
+	-@cpp/build/testconfig.pl --printwarnings
+
 
 
 dist-update:

=== cpp/build/Makefile ===
--- 
+++ 
@@ -13,12 +13,19 @@
 
 
 # what flags we will use for compiling in debug mode
-DEBUG_CFLAGS    := -Wall -Wno-unknown-pragmas -Wno-inline -Wno-format -Werror -Wno-error=sequence-point -Wno-sequence-point -ggdb -DDEBUG -fPIC  -DSYSCONFDIR="\"$(PREFIX)/etc/openzwave/\""
+DEBUG_CFLAGS    := -Wall -Wno-unknown-pragmas -Wno-inline -Wno-format -Werror -Wno-error=sequence-point -Wno-sequence-point -ggdb -DDEBUG -fPIC  -DSYSCONFDIR="\"$(PREFIX)/etc/openzwave/\"" -DOPENZWAVE_ENABLE_EXCEPTIONS=1
+DEBUG_CPPFLAGS  := -std=c++11 
 # what flags we will use for compiling in release mode
-RELEASE_CFLAGS  := -Wall -Wno-unknown-pragmas -Werror -Wno-format -Wno-error=sequence-point -Wno-sequence-point -O3 -DNDEBUG -fPIC  -DSYSCONFDIR="\"$(PREFIX)/etc/openzwave/\""
+RELEASE_CFLAGS  := -Wall -Wno-unknown-pragmas -Werror -Wno-format -Wno-error=sequence-point -Wno-sequence-point -O3 -DNDEBUG -fPIC  -DSYSCONFDIR="\"$(PREFIX)/etc/openzwave/\"" -DOPENZWAVE_ENABLE_EXCEPTIONS=1
+RELEASE_CPPFLAGS := -std=c++11
 #what flags we will use for linking in debug mode
 DEBUG_LDFLAGS	:= -g
 
+#default Libraries we should link with
+ifneq ($(UNAME),FreeBSD)
+LIBS += -lresolv
+endif
+
 top_srcdir := $(abspath $(dir $(lastword $(MAKEFILE_LIST)))../../)
 
 include $(top_srcdir)/cpp/build/support.mk
@@ -35,51 +42,92 @@
 #if we are on a Mac, add these flags and libs to the compile and link phases 
 ifeq ($(UNAME),Darwin)
 CFLAGS	+= -c -DDARWIN
-TARCH	+= -arch i386 -arch x86_64
-LDFLAGS += -dynamiclib
-LIBS	+= -framework IOKit -framework CoreFoundation -arch i386 -arch x86_64
+ifeq ($(DARWIN_MOJAVE_UP),1)
+# Newer macOS releases don't support i386 so only build 64-bit
+DARWIN_BUILD_TARGET = -arch x86_64
+else
+DARWIN_BUILD_TARGET = -arch i386 -arch x86_64
+endif
+TARCH	+= $(DARWIN_BUILD_TARGET)
+LDFLAGS += -dynamiclib -install_name "$(DESTDIR)/$(instlibdir)/$(SHARED_LIB_NAME)"
+LIBS	+= -framework IOKit -framework CoreFoundation $(DARWIN_BUILD_TARGET)
 else ifeq ($(UNAME),FreeBSD)
-
-# FreeBSD 10 has native iconv.h; for older, we look in /usr/local, and libiconv must be installed from ports.
-ifeq (,$(wildcard /usr/include/iconv.h))
+LDFLAGS+= -shared -lusb -Wl,-soname,$(SHARED_LIB_NAME)
+
+# Pre FreeBSD 10.2 we have no native, or "old" native iconv.h (non-posix compliant
+# const modifiers)
+# For these, require libiconv pkg to be installed.
+ifeq ($(shell test $$(uname -U) -ge 1002000; echo $$?),1)
+# <10.2
+ifeq (,$(wildcard /usr/local/include/iconv.h))
+$(error FreeBSD pre 10.2: Please install libiconv from ports)
+else
+# Installed, use it
 CFLAGS += -I/usr/local/include
-endif
-LDFLAGS+= -shared -lusb
-
-else
-LDFLAGS += -shared -Wl,-soname,libopenzwave.so.$(VERSION)
-LIBS 	+= -ludev
-endif
-CFLAGS  += $(CPPFLAGS)
+# User application *must* use -liconv; we don't do any linking from this file since we only
+# build a library.
+endif
+endif
+# For 10.2 and later, use iconv from base, no extra include path required.
+
+else ifeq ($(UNAME),NetBSD)
+CFLAGS += $(shell pkgconf --cflags libusb-1.0)
+LDFLAGS+= -shared $(shell pkgconf --libs libusb-1.0)
+else ifeq ($(UNAME),SunOS)
+CFLAGS+=  -I$(PREFIX)/include/libusb-1.0
+LDFLAGS+= -shared -lusb-1.0 -liconv
+else
+LDFLAGS += -shared -Wl,-soname,$(SHARED_LIB_NAME)
+endif
+#CFLAGS  += $(CPPFLAGS)
 
 #where to put the temporary library
 LIBDIR	?= $(top_builddir)
 
-INCLUDES	:= -I $(top_srcdir)/cpp/src -I $(top_srcdir)/cpp/tinyxml/ -I $(top_srcdir)/cpp/hidapi/hidapi/
+INCLUDES	:= -I $(top_srcdir)/cpp/src -I $(top_srcdir)/cpp/tinyxml/
+
+
+ifeq ($(USE_HID),1)
+INCLUDES += -I $(top_srcdir)/cpp/hidapi/hidapi/
+CFLAGS += -DUSE_HID
 
 ifeq ($(UNAME),Darwin)
 SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/mac
 else ifeq ($(UNAME),FreeBSD)
 SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/libusb
+else ifeq ($(UNAME),NetBSD)
+SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/libusb
+else ifeq ($(UNAME),SunOS)
+SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/libusb
 else
 SOURCES_HIDAPI =$(top_srcdir)/cpp/hidapi/linux
-endif
-
+LIBS += -ludev
+endif
+endif # USE_HID
 
 SOURCES		:= $(top_srcdir)/cpp/src $(top_srcdir)/cpp/src/command_classes $(top_srcdir)/cpp/tinyxml \
 	$(top_srcdir)/cpp/src/value_classes $(top_srcdir)/cpp/src/platform $(top_srcdir)/cpp/src/platform/unix $(SOURCES_HIDAPI) $(top_srcdir)/cpp/src/aes/
 VPATH = $(top_srcdir)/cpp/src:$(top_srcdir)/cpp/src/command_classes:$(top_srcdir)/cpp/tinyxml:\
 	$(top_srcdir)/cpp/src/value_classes:$(top_srcdir)/cpp/src/platform:$(top_srcdir)/cpp/src/platform/unix:$(SOURCES_HIDAPI):$(top_srcdir)/cpp/src/aes/
-	
 
 tinyxml := $(notdir $(wildcard $(top_srcdir)/cpp/tinyxml/*.cpp))
 
+ifeq ($(USE_HID),1)
 ifeq ($(UNAME),Darwin)
 hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/mac/*.c))
 else ifeq ($(UNAME),FreeBSD)
 hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/libusb/*.c))
+else ifeq ($(UNAME),NetBSD)
+hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/libusb/*.c))
+else ifeq ($(UNAME),SunOS)
+hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/libusb/*.c))
 else
 hidapi := $(notdir $(wildcard $(top_srcdir)/cpp/hidapi/linux/*.c)) # we do not want the libusb version
+endif
+endif # USE_HID
+
+ifeq ($(BITBAKE_ENV),1)
+ar_option := "rc"
 endif
 
 cclasses := $(notdir $(wildcard $(top_srcdir)/cpp/src/command_classes/*.cpp))
@@ -115,7 +163,7 @@
 	@echo 'uint16_t ozw_vers_minor = $(VERSION_MIN);' >> $(top_srcdir)/cpp/src/vers.cpp
 	@echo 'uint16_t ozw_vers_revision = $(VERSION_REV);' >> $(top_srcdir)/cpp/src/vers.cpp
 	@echo 'char ozw_version_string[] = "$(GITVERSION)";' >> $(top_srcdir)/cpp/src/vers.cpp
-	
+
 
 #$(OBJDIR)/vers.o:	$(top_builddir)/vers.cpp
 
@@ -128,7 +176,7 @@
 			$(patsubst %.cpp,$(OBJDIR)/%.o,$(indep)) \
 			$(OBJDIR)/vers.o
 	@echo "Linking Static Library"
-	@$(AR) $@ $+
+	@$(AR) $(ar_option) $@ $+
 	@$(RANLIB) $@
 
 $(LIBDIR)/$(SHARED_LIB_NAME):	$(patsubst %.cpp,$(OBJDIR)/%.o,$(tinyxml)) \
@@ -149,11 +197,12 @@
 		-e 's|[@]prefix@|$(PREFIX)|g' \
 		-e 's|[@]exec_prefix@|$(PREFIX)/bin|g' \
 		-e 's|[@]libdir@|$(instlibdir)|g' \
-		-e 's|[@]includedir@|$(PREFIX)/include/openzwave/|g' \
-                -e 's|[@]sysconfdir@|$(PREFIX)/etc/openzwave/|g' \
+		-e 's|[@]includedir@|$(includedir)/|g' \
+                -e 's|[@]sysconfdir@|$(sysconfdir)/|g' \
                 -e 's|[@]gitversion@|$(GITVERSION)|g' \
                 -e 's|[@]docdir@|$(docdir)/|g' \
 		-e 's|[@]VERSION@|$(VERSION)|g' \
+		-e 's|[@]LIBS@|$(LIBS)|g' \
 		< "$<" > "$@"
 $(top_builddir)/ozw_config: $(top_srcdir)/cpp/build/ozw_config.in
 	@echo "Making ozw_config file"
@@ -161,7 +210,7 @@
 		-e 's|[@]pkgconfigfile@|$(pkgconfigdir)/libopenzwave.pc|g' \
 		< "$<" > "$@"
 	@chmod +x $(top_builddir)/ozw_config
-	
+
 ifeq ($(DOT),)
 HAVE_DOT = -e 's|[@]HAVE_DOT@|NO|g' 
 else
@@ -219,7 +268,7 @@
 	@cp $(top_builddir)/ozw_config $(DESTDIR)/$(PREFIX)/bin/ozw_config
 	@chmod 755 $(DESTDIR)/$(PREFIX)/bin/ozw_config
 
-	
+
 
 .SUFFIXES:	.d .cpp .o .a
 .PHONY:	default clean install doc

=== cpp/test/Makefile ===
#
# Makefile for OpenzWave Mac OS X applications
# Greg Satz

# GNU make only

# requires libudev-dev

.SUFFIXES:	.d .cpp .o .a
.PHONY:	default clean


DEBUG_CFLAGS    := -Wall -Wno-format -ggdb -DDEBUG $(CPPFLAGS)
RELEASE_CFLAGS  := -Wall -Wno-unknown-pragmas -Wno-format -O3 $(CPPFLAGS)

DEBUG_LDFLAGS	:= -g

top_srcdir := $(abspath $(dir $(lastword $(MAKEFILE_LIST)))../../)

#where is put the temporary library
LIBDIR  	?= $(top_builddir)

INCLUDES	:= -I $(top_srcdir)/cpp/test/ -I $(top_srcdir)/cpp/test/include/ -I $(top_srcdir)/cpp/src -I $(top_srcdir)/cpp/tinyxml/ -I $(top_srcdir)/cpp/hidapi/hidapi/
LIBS = $(wildcard $(LIBDIR)/*.a )
#LIBSDIR = $(abspath $(dir $(firstword $(LIBS))))
SOURCES  := $(top_srcdir)/cpp/test/src/ $(top_srcdir)/cpp/test/
gtestsrc := $(notdir $(wildcard $(top_srcdir)/cpp/test/src/*.cc))
testsrc := $(notdir $(wildcard $(top_srcdir)/cpp/test/*.cpp))
VPATH := $(top_srcdir)/cpp/test/:$(top_srcdir)/cpp/test/src/

top_builddir ?= $(CURDIR)

default: $(top_builddir)/gtest-main

include $(top_srcdir)/cpp/build/support.mk

-include $(patsubst %.cc,$(DEPDIR)/%.d,$(gtestsrc))
-include $(patsubst %.cpp,$(DEPDIR)/%.d,$(testsrc))

#if we are on a Mac, add these flags and libs to the compile and link phases 
ifeq ($(UNAME),Darwin)
CFLAGS += -DDARWIN
TARCH += -arch x86_64
endif

# Dup from main makefile, but that is not included when building here..
ifeq ($(UNAME),FreeBSD)
LDFLAGS+= -lusb

ifeq ($(shell test $$(uname -U) -ge 1002000; echo $$?),1)
ifeq (,$(wildcard /usr/local/include/iconv.h))
$(error FreeBSD pre 10.2: Please install libiconv from ports)
else
CFLAGS += -I/usr/local/include
LDFLAGS+= -L/usr/local/lib -liconv
endif
endif

endif

$(OBJDIR)/%.o : %.cc
	@echo "Building $(notdir $@)"
	@$(CXX) -MM $(CFLAGS) $(INCLUDES) $< > $(DEPDIR)/$*.d
	@mv -f $(DEPDIR)/$*.d $(DEPDIR)/$*.d.tmp
	@$(SED) -e 's|.*:|$(OBJDIR)/$*.o: $(DEPDIR)/$*.d|' < $(DEPDIR)/$*.d.tmp > $(DEPDIR)/$*.d;
	@$(SED) -e 's/.*://' -e 's/\\$$//' < $(DEPDIR)/$*.d.tmp | fmt -1 | \
	  $(SED) -e 's/^ *//' -e 's/$$/:/' >> $(DEPDIR)/.$*.d;
	@rm -f $(DEPDIR)/$*.d.tmp
	@$(CXX) $(CFLAGS) $(TARCH) $(INCLUDES) -o $@ $<

$(top_builddir)/gtest-main:	$(patsubst %.cc,$(OBJDIR)/%.o,$(gtestsrc)) \
	$(patsubst %.cpp,$(OBJDIR)/%.o,$(testsrc))
	@echo "Linking $@"
	$(LD) $(LDFLAGS) $(TARCH) -o $@ $+ $(LIBS) -pthread

test:	$(top_builddir)/gtest-main
	$(top_builddir)/gtest-main

clean:
	@rm -rf $(DEPDIR) $(OBJDIR) $(top_builddir)/gtest-main

.SUFFIXES:	.d .cpp .cc .o .a

=== cpp/examples/MinOZW/Makefile ===
--- 
+++ 
@@ -17,9 +17,11 @@
 
 top_srcdir := $(abspath $(dir $(lastword $(MAKEFILE_LIST)))../../../)
 
+#where is put the temporary library
+LIBDIR  	?= $(top_builddir)
 
 INCLUDES	:= -I $(top_srcdir)/cpp/src -I $(top_srcdir)/cpp/tinyxml/ -I $(top_srcdir)/cpp/hidapi/hidapi/
-LIBS =  $(wildcard $(LIBDIR)/*.so $(LIBDIR)/*.dylib $(top_builddir)/*.so $(top_builddir)/*.dylib $(top_builddir)/cpp/build/*.so $(top_builddir)/cpp/build/*.dylib )
+LIBS =  $(wildcard $(LIBDIR)/*.so $(LIBDIR)/*.dylib $(top_builddir)/cpp/build/*.so $(top_builddir)/cpp/build/*.dylib )
 LIBSDIR = $(abspath $(dir $(firstword $(LIBS))))
 minozwsrc := $(notdir $(wildcard $(top_srcdir)/cpp/examples/MinOZW/*.cpp))
 VPATH := $(top_srcdir)/cpp/examples/MinOZW
@@ -35,16 +37,32 @@
 #if we are on a Mac, add these flags and libs to the compile and link phases 
 ifeq ($(UNAME),Darwin)
 CFLAGS += -DDARWIN
-TARCH += -arch i386 -arch x86_64
+ifeq ($(DARWIN_MOJAVE_UP),1)
+# Newer macOS releases don't support i386 so only build 64-bit
+TARCH	+= -arch x86_64
+else
+# Support older versions of OSX that may need to build both 32-bit and 64-bit
+TARCH	+= -arch i386 -arch x86_64
+endif
 endif
 
 # Dup from main makefile, but that is not included when building here..
 ifeq ($(UNAME),FreeBSD)
-ifeq (,$(wildcard /usr/include/iconv.h))
+LDFLAGS+= -lusb
+
+ifeq ($(shell test $$(uname -U) -ge 1002000; echo $$?),1)
+ifeq (,$(wildcard /usr/local/include/iconv.h))
+$(error FreeBSD pre 10.2: Please install libiconv from ports)
+else
 CFLAGS += -I/usr/local/include
 LDFLAGS+= -L/usr/local/lib -liconv
 endif
-LDFLAGS+= -lusb
+endif
+
+else ifeq ($(UNAME),NetBSD)
+LDFLAGS+= -L/usr/pkg/lib -lusb-1.0
+else ifeq ($(UNAME),SunOS)
+LDFLAGS+= -lusb-1.0
 endif
 
 $(OBJDIR)/MinOZW:	$(patsubst %.cpp,$(OBJDIR)/%.o,$(minozwsrc))

=== debian/changelog ===
openzwave (1.6+ds-1) experimental; urgency=medium

  * New upstream release
  * debian/watch: use version 4
  * debian/control: bump to version 4.3.0 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 12 May 2019 19:44:23 +0200

=== debian/control ===
Source: openzwave
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Section: devel
Priority: optional
Build-Depends: debhelper (>=11)
	, dh-exec (>=0.2)
	, g++ (>= 4.4)
	, quilt
	, libudev-dev
	, libxml2-utils
	, gcc-8, g++-8
Standards-Version: 4.3.0
Homepage: http://www.openzwave.com/
Vcs-Browser: https://salsa.debian.org/debian-iot-team/openzwave
Vcs-Git: https://salsa.debian.org/debian-iot-team/openzwave.git

Package: libopenzwave1.6
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: API to use a Z-Wave controller
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.
 .
 This package contains the library.

Package: libopenzwave1.6-dev
Section: libdevel
Depends: ${misc:Depends}, libopenzwave1.6 (= ${binary:Version})
Suggests: libopenzwave-doc
Architecture: any
Description: header files for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.
 .
 This package contains files for developing.

Package: libopenzwave-doc
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Architecture: all
Description: documentation for the openzwave library
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.
 .
 This package contains documentation.

Package: openzwave
Section: misc
Architecture: any
Depends: libopenzwave1.6 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Sample Program for libopenzwave
 OpenZWave is an open-source, cross-platform library designed to enable
 anyone to add support for Z-Wave home-automation devices to their
 applications, without requiring any in depth knowledge of the Z-Wave
 protocol.

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 MORECPPFLAGS=$(CFLAGS)
 MORELDFLAGS:=-Wl,-z,now
 
+#XXX no need to use this: export CC=gcc-8
+#XXX no need to use this: export CXX=g++-8
+
 ifndef DESTDIR
 DESTDIR=$(CURDIR)/debian/tmp/
 endif
@@ -23,7 +26,7 @@
 ifeq ($(strip $(REV)),)
   REV:=0
 endif
-DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+#XXX not really needed: DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LIBDIR := /usr/lib/$(DEB_HOST_MULTIARCH)/
 
@@ -49,6 +52,3 @@
 
 update_debian_version:
 	sed -i '1 s/(.*)/($(shell git describe --long --tags --dirty | sed s/-/./g | sed s/^v// ))/' debian/changelog
-
-get-orig-source:
-	uscan --force-download --debug --repack

## openzwave 1.6.1545%2Bds

=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.*\/[vV]?([\d\.-]+)\.tar\.gz/openzwave-$1.tar.gz/ \
https://github.com/OpenZWave/open-zwave/releases \
.*/archive/[vV]?([\d\.]+).tar.gz debian uupdate
